=== xbmc/programs/CMakeLists.txt ===
set(SOURCES GUIViewStatePrograms.cpp
            GUIWindowPrograms.cpp)

set(HEADERS GUIViewStatePrograms.h
            GUIWindowPrograms.h)

core_add_library(programs)
