=== xbmc/games/agents/CMakeLists.txt ===
set(SOURCES GameAgentManager.cpp
)

set(HEADERS GameAgentManager.h
)

core_add_library(games_agents)
