=== debian/changelog ===
kodi (2:20.5+dfsg-1ubuntu1) noble; urgency=medium

  * Fix Python 3.12 incompatibility with PyImport functions (LP: #2079914)

 -- Dave Jones <dave.jones@canonical.com>  Fri, 27 Sep 2024 22:20:30 +0100

kodi (2:20.5+dfsg-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:36:17 +0000

kodi (2:20.5+dfsg-1build1) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:02:29 +0000

kodi (2:20.5+dfsg-1) unstable; urgency=medium

  * New upstream version 20.5+dfsg

 -- Vasyl Gello <vasek.gello@gmail.com>  Tue, 05 Mar 2024 16:43:45 +0000

kodi (2:20.4+dfsg-1) unstable; urgency=medium

  * New upstream version 20.4+dfsg

 -- Vasyl Gello <vasek.gello@gmail.com>  Sun, 11 Feb 2024 07:12:03 +0000

kodi (2:20.3+dfsg-1) unstable; urgency=medium

  * New upstream version 20.3+dfsg (Closes: #1061600)
  * Build with APP_RENDER_SYSTEM=gles for arm platforms (Closes: #1056563)
  * Add pcre2 patch (Closes: #1000113)
  * Add workaround for LoongArch (Closes: #1054463)
  * Drop obsolete font metapackages from deps (Closes: #1050052)
  * Drop patches merged upstream
  * Update cdatetime-std-chrono patchset

 -- Vasyl Gello <vasek.gello@gmail.com>  Sat, 03 Feb 2024 13:51:04 +0000
